var gulp = require('gulp')
  , gutil = require('gulp-util')
  , del = require('del')
  , concat = require('gulp-concat')
  , rename = require('gulp-rename')
  , minifycss = require('gulp-minify-css')
  , minifyhtml = require('gulp-minify-html')
  , processhtml = require('gulp-processhtml')
  , jshint = require('gulp-jshint')
  , streamify = require('gulp-streamify')
  , uglify = require('gulp-uglify')
  , connect = require('gulp-connect')
  , source = require('vinyl-source-stream')
  , browserify = require('browserify')
  , watchify = require('watchify')
  , gulpif = require('gulp-if')
  , vinylPaths = require('vinyl-paths')
  , notifier = require('node-notifier')
  , paths;

var watching = false;

paths = {
  assets: 'src/assets/**/*',
  css:    'src/css/*.css',
  libs:   [
    './src/bower_components/phaser-official/build/phaser.js',
    './src/bower_components/chance/chance.js'
    //,'./src/bower_components/stacktrace-js/dist/stacktrace.js'
  ],
  js:     ['src/js/*.js', 'src/js/**/*.js'],
  entry: './src/js/main.js',
  dist:   './dist/'
};

gulp.task('clean', function () {

    //return gulp.src( paths.dist )
    //.pipe(vinylPaths(del))
    //.on('error', gutil.log);

    //var millis = 500;
    //
    //var date = new Date();
    //var curDate = null;
    //
    //do { curDate = new Date(); }
    //    while(curDate-date < millis) {
    //};

});

gulp.task('copy', ['clean'], function () {
  gulp.src(paths.assets)
    .pipe(gulp.dest(paths.dist + 'assets'))
    .on('error', gutil.log);
});

gulp.task('copylibs', ['clean'], function () {
  gulp.src(paths.libs)
    .pipe(gulpif(!watching, uglify({outSourceMaps: false})))
    .pipe(gulp.dest(paths.dist + 'js/lib'))
    .on('error', gutil.log);
});

gulp.task('compile', ['clean'], function () {

  var bundler = browserify({
    cache: {}, packageCache: {}, fullPaths: true,
    entries: [paths.entry],
    debug: watching
  });

  var bundlee = function() {

      //console.log("drint");


      //var millis = 1500;
      //
      //var date = new Date();
      //var curDate = null;
      //
      //do { curDate = new Date(); }
      //    while(curDate-date < millis) {
      //};


      //fs = require('fs')
      //fs.readFile('dist\\main.min.js', 'utf8', function (err,data) {
      //    if (err) {
      //        return console.log("Geht nich", err);
      //    }
      //    console.log(data);
      //});


    return bundler
      .bundle()
      .pipe(source('main.min.js'))
      .pipe(jshint('.jshintrc'))
      .pipe(jshint.reporter('default'))
      .pipe(gulpif(!watching, streamify(uglify({outSourceMaps: false}))))
      .pipe(gulp.dest(paths.dist))
      .on('error', function(err){
        console.log(err.message);
        this.end();
      });
      // .on('error', gutil.log);
  };


  if (watching) {
      //console.log("ran", count);

      //if (count == 0) {
      //    console.log("doing it");
          bundler = watchify(bundler);
          bundler.on('update', bundlee)
      //}
      //
      //count++;
  }

  return bundlee();
});

gulp.task('compile2', ['clean'], function () {
    var bundler = browserify({
        cache: {}, packageCache: {}, fullPaths: true,
        entries: [paths.entry],
        debug: watching
    });
    if (watching) {
        bundler = watchify(bundler);
        bundler.on('update', bundlee)
    }

    var bundlee = function() {
        return bundler
            .bundle()
            .pipe(source('main.min.js'))
            .pipe(jshint('.jshintrc'))
            .pipe(jshint.reporter('default'))
            .pipe(gulpif(!watching, streamify(uglify({outSourceMaps: false}))))
            .pipe(gulp.dest(paths.dist))
            .on('error', handleErr);
    };

    function handleErr(err) {
        setTimeout(function () {
            bundlee();
        }, 100)
    }

    return bundlee();
});

gulp.task('minifycss', ['clean'], function () {
 gulp.src(paths.css)
    .pipe(gulpif(!watching, minifycss({
      keepSpecialComments: false,
      removeEmpty: true
    })))
    .pipe(rename({suffix: '.min'}))
    .pipe(gulp.dest(paths.dist))
    .on('error', gutil.log);
});

gulp.task('processhtml', ['clean'], function() {
  return gulp.src('src/index.html')
    .pipe(processhtml())
    .pipe(gulp.dest(paths.dist))
    .on('error', gutil.log);
});

gulp.task('minifyhtml', ['processhtml'], function() {
  gulp.src('dist/index.html')
    .pipe(gulpif(!watching, minifyhtml()))
    .pipe(gulp.dest(paths.dist))
    .on('error', gutil.log);
});

gulp.task('html', ['build'], function(){
  gulp.src('dist/*.html')
    .pipe(connect.reload())
    .on('error', gutil.log);
});

gulp.task('connect', function () {
  connect.server({
    root: ['./dist'],
    port: 9696,
    livereload: true
  });
});

gulp.task('watch', function () {
  watching = true;
  return gulp.watch(['./src/index.html', paths.css, paths.js], ['build', 'html']);
});

var count = 0;

gulp.task('default', ['connect', 'watch', 'build']);

gulp.task('build', [
        'clean',
        'copy',
        'copylibs',
        'compile',
        'minifycss',
        'processhtml',
        'minifyhtml'
    ], function() {
        notifier.notify({title: 'gulp build', message: 'done'});
    });
