var Player = require('../entities/player');
var BadPerson = require('../entities/badppl');

var Game = function () {
  this.testentity = null;
};

module.exports = Game;

var LAYER_TILES          = "Background"
var LAYER_COLLECTABLES   = "Collectables"
var LAYER_EYECANDY       = "Eye Candy"

var playerspeed = 120;

var emittermaxdist = 200;
var emitterduration = 1000;
var emittercooldown = 1500;
var emitterburntime = 500;

Game.prototype = {

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//      P R E L O A D
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

    preload: function() {

        this.game.stage.backgroundColor = '#3d3d3d';

        this.load.tilemap('map', './assets/level/level1.json', null, Phaser.Tilemap.TILED_JSON); // loading the tilemap file


    },



// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//      C R E A T E
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

    create: function () {

    // init physics system
        this.game.physics.startSystem(Phaser.Physics.ARCADE);

        this.status = {
            spacebar: false,
            debug: true,
            smileeemitter: null,
            canshoot: true,
            isShooting: false,
            badppl: [],
            groups: {}
        };

        this.debug = {
            line: new Phaser.Line(),
            tileHits: [],
            plotting: false
        }

    // SOUNDS
    // ===========

        //this.sounds = {
        //    collect:       this.game.add.audio('snd_collect', 1, true)
        //}


    // FILTERS
    // ==============




    // CREATE LEVEL
    // =================

        this._createLevel();



    // PLAYER
    // ==============

        this.player = new Player(this.game, 50, 50);
        this.game.physics.enable(this.player, Phaser.Physics.ARCADE);

        this.player.body.collideWorldBounds = true;

        this.game.camera.follow(this.player, Phaser.Camera.FOLLOW_PLATFORMER);

        //this.game.input.onDown.add(this._startLine, this);

        this.game.input.onUp.add(this._shootSmilee, this);
        //this.game.input.onUp.add(this._gameOver, this);


        this.cursors = this.game.input.keyboard.createCursorKeys();


    // BADPPL
    // ==============

        //  The enemies bullet group
        this.status.groups.enemyBullets = this.game.add.group();
        this.status.groups.enemyBullets.physicsBodyType = Phaser.Physics.ARCADE;
        this.status.groups.enemyBullets.enableBody = true;
        this.status.groups.enemyBullets.createMultiple(50, 'bullet');

        this.status.groups.enemyBullets.setAll('anchor.x', 0.5);
        this.status.groups.enemyBullets.setAll('anchor.y', 0.5);
        this.status.groups.enemyBullets.setAll('outOfBoundsKill', true);
        this.status.groups.enemyBullets.setAll('checkWorldBounds', true);


        // the bad ppl themselfs
        this.status.groups.badppl = this.game.add.group();

        //this.status.groups.badppl.physicsBodyType = Phaser.Physics.ARCADE;
        //this.status.groups.badppl.enableBody = true;

        this._addBadPerson(0, 50, 220, 200, 200, 2500);
        this._addBadPerson(1, 450, 70, 450, 220, 2500);
        this._addBadPerson(2, 70, 300, 250, 500, 1500);
        this._addBadPerson(3, 320, 300, 340, 570, 2000);
        this._addBadPerson(4, 340, 300, 767, 304, 2000);
        this._addBadPerson(5, 600, 80, 600, 210, 2000);
        this._addBadPerson(6, 980, 90, 1130, 82, 2000);
        this._addBadPerson(7, 1130, 200, 980, 210, 2000);
        this._addBadPerson(8, 1190, 295, 800, 300, 2000);
        this._addBadPerson(9, 675, 212, 880, 210, 2000);
        this._addBadPerson(10, 1190, 295, 800, 300, 2000);


    // SMILEE EMITTER
    // =================
        this._createSmileeEmitter();

        this.status.smileebullet = this.game.add.sprite(100, 100, "smilee");
        this.game.physics.enable(this.status.smileebullet, Phaser.Physics.ARCADE);
        //this.status.smileebullet.enableBody = true;
        this.status.smileebullet.scale = {x: 0.35, y: 0.35};
        this.status.smileebullet.alpha = 0;
        this.status.smileebullet.anchor.setTo(0.5, 0.5);



    // CRT SCANLINES
    // =================

        // TODO: put this into filters
        //this.scanlines = this.add.sprite(0,0,'scanlines');
        //this.scanlines.fixedToCamera = true;
        //this.scanlines.blendMode = PIXI.blendModes.SCREEN;

    // SCORE
    // ======
        this.status.score = {
            pacified: 0,
            smiled: 0,
            starttime: 0,
            stamina: 5,
            text:
                this.game.add.text(380, 574, "", {
                    font: "23px Audiowide",
                    fill: "#FFFFFF",
                    align: "right"
                })
        };
        this.status.score.text.fixedToCamera = true;
        this._updateScore();


  },


    _updateScore: function() {

        var text = "Smiled: " + this.status.score.smiled + ", Pacified: " + this.status.score.pacified + ", Stamina: "
            + this.status.score.stamina;

        this.status.score.text.setText(text);

    },

    _addBadPerson: function(id, fx, fy, tx, ty, speed) {

        var nubp = new BadPerson(
            this,
            this.game,
            new Phaser.Point(fx, fy),
            new Phaser.Point(tx, ty),
            speed
        );

        this.game.physics.enable(nubp, Phaser.Physics.ARCADE);

        this.status.groups.badppl.add(nubp);

        nubp.body.collideWorldBounds = true;
        nubp.start();

        this.status.badppl[id] = nubp;

    },

// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//      C R E A T E LEVEL
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

    _createLevel: function() {

    this.leveldata = {
        tilemap:        null,
        playerblocks:   null,

        layer_tilelayer:      null,
        layer_collectables:   null,
        layer_eyecandy:       null
    }

    // TILEMAP
    this.leveldata.tilemap = this.add.tilemap('map');                       // Preloaded tilemap
    this.leveldata.tilemap.addTilesetImage('Basic Set', 'tiles_level1');   // Preloaded tileset

    // activate collision for blocks a till b
    this.leveldata.tilemap.setCollisionBetween(500, 1500, true, LAYER_TILES);

    // catch collect events for ...
    //this.leveldata.tilemap.setTileIndexCallback(
    //    [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,80], this._collectIt, this, Level2.LAYER_COLLECTABLES);

    // TILE LAYERS
    this.leveldata.layer_tilelayer    = this.leveldata.tilemap.createLayer(LAYER_TILES);    // This is the default name of the first layer in Tiled
    //this.leveldata.layer_eyecandy     = this.leveldata.tilemap.createLayer(LAYER_EYECANDY);
    //this.leveldata.layer_collectables = this.leveldata.tilemap.createLayer(LAYER_COLLECTABLES);

    this.leveldata.layer_tilelayer.debug = false;

    //this.leveldata.layer_tilelayer.scale.set(2, 2);

    this.leveldata.layer_tilelayer.resizeWorld();                        // Sets the world size to match the size of this layer.



    //console.log(this.leveldata.layer_tilelayer);
    //console.log(this.leveldata.layer_eyecandy);
},


    _createSmileeEmitter: function() {

        this.status.smileeemitter = this.game.add.emitter(0, 0, 200);
        this.status.smileeemitter.makeParticles('smilee',0,50,false,false);

        //this.status.smileeemitter.enableBody = true;
        //this.status.smileeemitter.physicsBodyType = Phaser.Physics.P2JS;
        //this.status.smileeemitter.setYSpeed(250, 0);

        this.status.smileeemitter.setRotation(0, 0.3);
        this.status.smileeemitter.setAlpha(0.1, 1, 3000);
        this.status.smileeemitter.setScale(0.1, 1, 0.1, 1, 6000, Phaser.Easing.Quintic.Out);
        this.status.smileeemitter.gravity = -200;

    },


    _startSmileeEmitter: function(start, end) {

        if (!this.status.canshoot) {
            // TODO: sound - mööööp
            console.log("can't shoot, still cooling down");
            return;
        }

        var dist = new Phaser.Point(start.x - end.x, start.y - end.y);

        if (dist.getMagnitude() > emittermaxdist) {
            // TODO: sound - mööööp
            console.log("can't shoot, too far");
            return;
        }

        this.status.score.smiled++;
        this._updateScore();

        var animspeed = Math.round( (emitterduration * dist.getMagnitude()) / emittermaxdist);
        console.log("Animspeed: ", animspeed);

    // EMITTER
    // =============

        this.status.smileeemitter.x = start.x;
        this.status.smileeemitter.y = start.y;
        this.status.smileeemitter.start(false, emitterduration, 50, (emitterduration+emitterburntime) / 50);   //explode, lifespan, .. , count

        this.status.canshoot = false;
        this.status.isShooting = true;

        // TWEEN: emitter
        this.status.smileetween = this.game.add.tween(this.status.smileeemitter).to(
            {emitX: end.x, emitY: end.y},
            animspeed,
            Phaser.Easing.Linear.None,
            true,0,0,false);

        // TWEEN: emitter complete
        this.status.smileetween.onComplete.add(function(){
            var that = this;

            that.status.isShooting = false;

            // keep burning a while
            setTimeout(function() {
                var thot = that;
                thot.status.smileeemitter.on = false;
            }, emitterburntime);

            // cooldown time till next shot
            setTimeout(function(){
                var thot = that;
                thot.status.canshoot = true;
                console.log("Cooled down!");
            }, emittercooldown);
        }, this);



    // BULLET
    // ==========

        this.status.smileebullet.x = start.x;
        this.status.smileebullet.y = start.y;
        this.status.smileebullet.alpha = 0.7;
        this.status.smileebullet.body.enable = true;

        this.player.sounds.smilee.play();

        // TWEEN: bullet
        this.status.smileeBtween = this.game.add.tween(this.status.smileebullet).to(
            {x: end.x, y: end.y, angle: 360},
            animspeed,
            Phaser.Easing.Linear.None,
            true,0,0,false);


        // TWEEN: bullet complete
        var that = this;
        this.status.smileeBtween.onComplete.add(function() {
            var thot = that;
            thot.status.smileebullet.body.enable = false;
            thot.status.playertouching = null;
            thot.status.smileeBtween = thot.game.add.tween(thot.status.smileebullet).to(
                {alpha: 0},
                emitterburntime,
                Phaser.Easing.Linear.None,
                true, 0, 0, false);
        });

    },

    _createSmileeEmitter_: function(start, end) {

        if (this.status.smileeemitter == null) {

            if (start.x > end.x) {
                var t = start.x;
                start.x = end.x;
                end.x = t;
            }

            if (start.y > end.y) {
                var t = end.y;
                end.y = start.y;
                start.y = t;
            }

            var size = new Phaser.Point(end.x - start.x, end.y - start.y)

            console.log(start, end, end.x - start.x, end.y - start.y);

            //	Emitters have a center point and a width/height, which extends from their center point to the left/right and up/down
            this.status.smileeemitter = this.game.add.emitter(start.x, start.x, size.x, size.y);

            //	This emitter will have a width of 800px, so a particle can emit from anywhere in the range emitter.x += emitter.width / 2
            // emitter.width = 800;

            this.status.smileeemitter.makeParticles('smilee');

            // emitter.minParticleSpeed.set(0, 300);
            // emitter.maxParticleSpeed.set(0, 600);

            this.status.smileeemitter.setRotation(0, 0.3);
            this.status.smileeemitter.setAlpha(0.1, 1, 3000);
            this.status.smileeemitter.setScale(0.1, 1, 0.1, 1, 6000, Phaser.Easing.Quintic.Out);
            this.status.smileeemitter.gravity = -200;

            this.status.smileeemitter.start(false, emitterduration, 10);

            this.status.smileeemitter.emitX = 0;

            this.status.smileetween = this.game.add.tween(this.status.smileeemitter).to(
                {emitX: size.x, emitY: size.y},
                2000,
                Phaser.Easing.Linear.None,
                true,
                0,
                0,
                false);
            this.status.smileetween.onComplete.add(function(){
                this.status.smileeemitter.on = false;
                var that = this;
                setTimeout(function(){
                    var thot = that;
                    thot.status.smileeemitter.destroy();
                    thot.status.smileeemitter = null;
                }, emitterduration);

            }, this);

        } else {

            console.log("too tsunami");

        }
    },


    _smileeBadpplCollision: function(psprite, pblock) {

        pblock.smileeHit();

    },

    _playerBadpplCollision: function(psprite, pblock) {

        this.status.playertouching = pblock;

    },

    _playerBulletCollision: function(psprite, pblock) {

        pblock.kill();

        this.status.score.stamina--;
        this._updateScore();

        if (this.status.score.stamina == 0) {
            this.game.paused = true;
            this._gameOver();
        }

    },

    _gameOver: function() {

        var x = this.game.width / 2;
        var y = this.game.height / 2;

        this.camera.x = 0;
        this.camera.y = 0;

        var graphics = this.game.add.graphics(130, 80);
        graphics.lineStyle(0);
        graphics.beginFill(0xFFFF0B, 0.8);
        graphics.beginFill(0xffaf18, 0.88);
        graphics.drawRect(0, 0, 500, 400);
        graphics.endFill();

        var score = "Smiled: " + this.status.score.smiled + ", Pacified: " + this.status.score.pacified + ", Stamina: "
            + this.status.score.stamina;

        var gotext = this.game.add.text(170, 100, "", {
            font: "23px Audiowide",
            fill: "#FFFFFF",
            align: "center",
            wordWrap: true,
            wordWrapWidth: 450
        });
        gotext.setText("GAME OVER\n\rThanks for playing this little thing, whatever you may call it.\n Your final score was:\r" + score);


        var style_sub = {font: "italic 18px Audiowide", fill: "#444444", align: "center"};
        this.text = this.add.text(x, y + 150, "Reload to Restart", style_sub);
        this.text.anchor.set(0.5);

        this.game.input.onUp.add( this._goBack, this );

    },



// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//      U P D A T E
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

  update: function () {

      //if (this.debug.plotting && this.status.debug ) {
      //    this.debug.line.end.set(this.game.input.activePointer.worldX, this.game.input.activePointer.worldY);
      //}

  // COLLISION DETECTION
  // ---------------------
      // PLAYER <-> WORLD
      this.game.physics.arcade.collide(this.player, this.leveldata.layer_tilelayer);

      // SMILEE <-> BADPPL
      this.game.physics.arcade.overlap(
          this.status.smileebullet,
          this.status.groups.badppl,
          this._smileeBadpplCollision, null, this);

      // PLAYER <-> BADPPL
      var isTouchingBad = this.game.physics.arcade.overlap(
          this.player,
          this.status.groups.badppl,
          this._playerBadpplCollision, null, this);

      // PLAYER <-> BULLET
      this.game.physics.arcade.overlap(
          this.player,
          this.status.groups.enemyBullets,
          this._playerBulletCollision, null, this);


      if (!isTouchingBad)
          this.status.playertouching = null;


  // PLAYER
  // ------------

      this._updatePlayer();



  // BADPPL
  // ---------

      this._updateBadPpl();




  // RELOAD
  // ---------
      if (    this.game.input.keyboard.isDown(Phaser.Keyboard.P)
          ||  this.game.input.keyboard.isDown(Phaser.Keyboard.R)) {
          //this.input.onDown.add(this.onInputDown, this);
          this._goBack()
      }

  // OPEN DOOR
  // -----------
      if (this.game.input.keyboard.isDown(Phaser.Keyboard.SPACEBAR) ) {
          if (!this.status.spacebar) {
              this.status.spacebar = true;

              // TODO: open door

              //// see if we find a bad guy close by
              //console.log(this.player.body);
              //console.log(this.player);
              //for (i = 0; i< this.status.badppl.length; i++) {
              //    console.log(this.status.badppl[i].body.sprite.bounds, this.player.body.sprite.bounds);
              //    console.log(Phaser.Rectangle.intersects(this.status.badppl[i].body.sprite._bounds, this.player.bounds));
              //}

              if (this.status.playertouching !== null) {
                  this.status.playertouching.bigHit();
                  this.status.score.pacified++;
                  this._updateScore();
              }

              console.log("SPAAAACEBAR");
          }
      } else {
          this.status.spacebar = false;
      }

  // DEBUG
  // ---------
  //    if (    this.game.input.keyboard.isDown(Phaser.Keyboard.I)
  //        ||  this.game.input.keyboard.isDown(Phaser.Keyboard.C)) {
  //        if (!this.status.debug) {
  //            this.status.debug = true;
  //            this.leveldata.layer_tilelayer.debug = true;
  //        }
  //    } else {
  //        this.status.debug = false;
  //        this.leveldata.layer_tilelayer.debug = false;
  //    }

  },


  _updateBadPpl: function() {

      this.status.badppl.forEach(function(element, index, array){

          if (element.settings.status == "normal") {
              if (element._canSeePlayer(this.player)) {
                  element._foundPlayer(this.player);
              }
          }

      }, this);

  },


  _updatePlayer: function() {

      var x, y, cx, cy, angle;

  // ROTATE
  // ----------
      x = this.input.position.x;
      y = this.input.position.y;
      cx = this.player.x  - this.camera.x;
      cy = this.player.y - this.camera.y;

      angle = Math.atan2(y - cy, x - cx) * (180 / Math.PI);
      this.player.angle = (angle + 90) % 360;

  // MOVE
  // --------
      this.player.body.velocity.x = 0;
      this.player.body.velocity.y = 0;

  // UP
  // -----
      if (  this.cursors.up.isDown
        ||  this.game.input.keyboard.isDown(Phaser.Keyboard.W)
        ||  this.game.input.keyboard.isDown(188)
      ){
          this.player.body.velocity.y = -playerspeed;
      } else

  // DOWN
  // -----
      if (    this.cursors.down.isDown
          ||  this.game.input.keyboard.isDown(Phaser.Keyboard.O)
          ||  this.game.input.keyboard.isDown(Phaser.Keyboard.S)) {
          this.player.body.velocity.y = playerspeed;
      }

  // LEFT
  // ------
      if (    this.cursors.left.isDown
          ||  this.game.input.keyboard.isDown(Phaser.Keyboard.A)){
          this.player.body.velocity.x = -playerspeed;
      } else

  // RIGHT
  // -------
      if (    this.cursors.right.isDown
          ||  this.game.input.keyboard.isDown(Phaser.Keyboard.E)
          ||  this.game.input.keyboard.isDown(Phaser.Keyboard.D)){
          this.player.body.velocity.x = playerspeed;
      }

      if (this.player.body.velocity.x != 0 || this.player.body.velocity.y != 0) {
          if (!this.player.isWalking) {
              this.player.isWalking = true;
              this.player.sounds.walking.play();
          }
      } else {
          if (this.player.isWalking) {
              this.player.isWalking = false;
              this.player.sounds.walking.stop();
          }
      }

    // console.log("Key: ", this.game.input.keyboard.lastKey);


      //dx = x - cx;
      //dy = y - cy;
      //scale = Math.sqrt(dx * dx + dy * dy) / 100;

      //this.player.scale.x = scale * 0.6;
      //this.player.scale.y = scale * 0.6;
  },


    _goBack: function () {
        this.game.state.start('Menu');
      },




// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//      R E N D E R
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

    render: function() {

        // this.game.debug.geom(this.debug.line);

    },






// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//      S H O O T
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

    _shootSmilee: function(pointer) {

        var target = null;
        var tileHits = this._raycast(pointer);
        if ( tileHits.length > 0) {
            target = new Phaser.Point(
                tileHits[0].worldX,
                tileHits[0].worldY);
        } else {
            target = new Phaser.Point(pointer.x+this.camera.x, pointer.y+this.camera.y);
        }
        // Start ray
        this._startSmileeEmitter(this.player.world,target);

        console.log("Mouse: ", pointer.x+this.camera.x, pointer.y+this.camera.y);


    },




// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//      T O O L S
// >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>

    _startLine: function(pointer) {

        if (this.debug.tileHits.length > 0)
        {
            for (var i = 0; i < this.debug.tileHits.length; i++)
            {
                this.debug.tileHits[i].debug = false;
            }

            this.leveldata.layer_tilelayer.dirty = true;
        }

        this.debug.line.start.set(pointer.worldX, pointer.worldY);

        this.debug.plotting = true;

    },

    /**
     * Returns the amount of solid blocks that lie between the player ond the given point. In debug mode those blocks
     * are marked (only works for the latest ray
     * @param pointer
     * @returns {*}
     * @private
     */
    _raycast: function(pointer, start) {

        var ret = [];

        if (typeof start === "undefined")
            this.debug.line.start.set(this.player.x, this.player.y);
        else
            this.debug.line.start.set(start.x, start.y);

        this.debug.line.end.set(pointer.worldX, pointer.worldY);


        ret = this.leveldata.layer_tilelayer.getRayCastTiles(this.debug.line, 4, true, true);
        this.debug.tileHits = ret;

        // now cast also the bad ppl one


        //if (this.debug.tileHits.length > 0) {
        //    //  Just so we can visually see the tiles
        //    for (var i = 0; i < this.debug.tileHits.length; i++) {
        //        this.debug.tileHits[i].debug = true;
        //    }
        //    this.leveldata.layer_tilelayer.dirty = true;
        //}

        this.debug.plotting = false;

        return ret;

    }






};
